Ext.define("M1CRM.model.crmCustomerLocationAddEdit", {
  extend: "Ext.data.Model",
  config: {
    fields: [
      {name: 'LocationID', type: 'string', defaultValue: ''},
      {name: 'OrganizationID', type: 'string', defaultValue: ''},
      {name: 'OrganizationName', type: 'string', defaultValue: ''},
      {name: 'LocationName', type: 'string', defaultValue: ''},
      {model: 'M1CRM.model.crmAddress', name: 'Address'},
      {model: 'M1CRM.model.crmContactDetail', name: 'ContactDetail'},
      {name: 'QuoteLocation', type: 'bool', defaultValue: false},
      {name: 'ShipLocation', type: 'bool', defaultValue: false},
      {name: 'ARInvoiceLocation', type: 'bool', defaultValue: false},
      {name: 'CustomerShippingMethodID', type: 'string', defaultValue: ''},
      {name: 'CustomerTaxable', type: 'bool', defaultValue: false},
      {name: 'CustomerTaxCodeID', type: 'string', defaultValue: ''},
      {name: 'CustomerSecondTaxCodeID', type: 'string', defaultValue: ''},
      {name: 'EmployeeID', type: 'string', defaultValue: ''}

    ],
    validations: [
      {type: 'presence', field: 'LocationID', message: 'Enter Location ID'},
      {type: 'presence', field: 'LocationName', message: 'Enter Location Name'},
      {type: 'format', field: 'CustomerTaxable', message: 'Enter Tax ID'}
    ]

  },

  constructor: function(data, id, raw, convertedData) {
    var me = this,
    cached = null,
    useCache = me.getUseCache(),
    idProperty = me.getIdProperty();

    data = data || convertedData || {};

    // We begin by checking if an id is passed to the constructor. If this is the case we override
    // any possible id value that was passed in the data.
    if (id || id === 0) {
      // Lets skip using set here since it's so much faster
      data[idProperty] = me.internalId = id;
    }

    // If we have an id set in the data we check to see if we already have a cached instance
    // of this record. If that's the case then we just return that instance with the updated data
    // passed to this constructor.
    id = data[idProperty];
    if (useCache && (id || id === 0)) {
      cached = Ext.data.Model.cache[Ext.data.Model.generateCacheId(this, id)];
      if (cached) {
        cached.raw = raw || cached.raw;
        return cached.mergeData(convertedData || data || {});
      }
    }

    /**
     * @property {Object} modified key/value pairs of all fields whose values have changed.
     * The value is the original value for the field.
     */
    me.modified = {};

    /**
     * @property {Object} raw The raw data used to create this model if created via a reader.
     */
    me.raw = raw || data || {};

    /**
     * @property {Array} stores
     * An array of {@link Ext.data.Store} objects that this record is bound to.
     */
    me.stores = [];

    if (convertedData) {
      me.setConvertedData(data);
    } else {
      me.setData(data);
    }

    // me.id is always set to be randomly generated and should only be used for binding Observable events!
    me.id = me.getIdentifier().generate(me);

    // If it does not have an id in the data at this point, we use the one generated by the id strategy.
    // This means that we will treat this record as a phantom record from now on
    id = me.data[idProperty];
    if (!id && id !== 0) {
      me.data[idProperty] = me.internalId = me.id;
      me.phantom = true;

      // If we only now set an id on this model, it means we setData won't have handled the inline
      // association data, which we will have to do now then.
      if (this.associations.length) {
        this.handleInlineAssociationData(data);
      }
    }
    else {
      // We also want to make sure that the internalId has the same value as the id in
      // the data object.
      this.internalId = id;
    }

    if (useCache) {
      Ext.data.Model.cache[Ext.data.Model.generateCacheId(me)] = me;
    }

    if (this.init && typeof this.init == 'function') {
      this.init();
    }

    // Validation if customer is taxable
    this.config.validations[2].matcher = {
      scope: this,
      test: function() {
        if (this.scope.data.CustomerTaxable) {
          return !_.isEmpty(this.scope.data.CustomerTaxCodeID)
        }

        return true;
      }
    };
  },

  getData: function (settings) {
    Ext.create('M1CRM.model.crmServiceAccessModel', {}).getIt({
      scope: this,
      ViewID: 'CRMCUSTOMERLOCADDEDIT',
      RequestID: settings.RequestID,
      jsondataObj: JSON.stringify(Ext.create('M1CRM.model.crmDataFilterModel', {
        FilterValues: [this.data.OrganizationID, this.data.LocationID]
      }).data),
      onReturn: function (result) {
        if (result != null) {
          settings.onReturn.apply(settings.scope, [Ext.decode(result).DataObject]);
        } else {
          settings.onReturn.apply(settings.scope, [null]);
        }
      }
    });
  },

  saveData: function (settings) {
    this.data.EmployeeID = SessionObj.getEmpId();
    Ext.create('M1CRM.model.crmServiceAccessModel', {}).saveIt({
      scope: this,
      ViewID: 'CRMCUSTOMERLOCADDEDIT',
      jsondataObj: JSON.stringify(this.data),
      onReturn: function (result) {
        if (result != null) {
          settings.onReturn.apply(settings.scope, [Ext.decode(result).DataObject]);
        } else {
          settings.onReturn.apply(settings.scope, [null]);
        }
      }
    });
  }


});

